// TsDescrambler.cpp: CTsDescrambler NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsDescrambler.h"
#include <time.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
static DWORD WINAPI RecvThread(LPVOID param)
{
	CTsDescrambler* pThis = (CTsDescrambler*)param;

	while(!pThis->m_bEnd) {
		EnterCriticalSection(&pThis->cs);
		if(pThis->m_nMaxCount < pThis->m_nCount)
			pThis->m_nMaxCount = pThis->m_nCount;
		while(pThis->m_nCount > 0 && !pThis->m_bEnd) {
			pThis->InputMediaBuffer(pThis->m_PacketCache[pThis->m_nRead]);
			pThis->m_nRead++;
			pThis->m_nCount--;
			if(pThis->m_nRead == CACHE_MAX)
				pThis->m_nRead = 0;
		}
		LeaveCriticalSection(&pThis->cs);
		Sleep(1);
	}
	return 0;
}

CTsDescrambler::CTsDescrambler()
	: IMediaDecoder()
	, m_dwInputPacketCount(0)
	, m_dwOutputPacketCount(0)
	, m_bReOpen(FALSE)
	, m_bEnd(FALSE)
	, m_nRead(0)
	, m_nWrite(0)
	, m_nCount(0)
	, m_nMaxCount(0)
{
	// ECM PID}bv		
	::FillMemory(m_awEcmPidMap, sizeof(m_awEcmPidMap), 0xFF);
	InitializeCriticalSection(&cs);
	m_hRecvThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)::RecvThread,this,0,NULL);
}

CTsDescrambler::~CTsDescrambler()
{
	CloseBcasCard();
	if(m_hRecvThread) {
		m_bEnd = TRUE;
		WaitForSingleObject(m_hRecvThread,1000);
		EnterCriticalSection(&cs);
		while(m_nCount > 0) {
			m_PacketCache[m_nRead]->Delete();
			m_nRead++;
			m_nCount--;
			if(m_nRead == CACHE_MAX)
				m_nRead = 0;
		}
		LeaveCriticalSection(&cs);
		CloseHandle(m_hRecvThread);
		m_hRecvThread = NULL;
	}
	DeleteCriticalSection(&cs);
}

void CTsDescrambler::Reset(void)
{
	EnterCriticalSection(&cs);
	while(m_nCount > 0) {
		m_PacketCache[m_nRead]->Delete();
		m_nRead++;
		m_nCount--;
		if(m_nRead == CACHE_MAX)
			m_nRead = 0;
	}
	LeaveCriticalSection(&cs);
	// Ԃ
	m_PatTable.Reset();
	m_PmtList.clear();
	m_EcmList.clear();

	::FillMemory(m_awEcmPidMap, sizeof(m_awEcmPidMap), 0xFF);

	// vf[^
	m_dwInputPacketCount = 0;
	m_dwOutputPacketCount = 0;

	// fR[_
	IMediaDecoder::Reset();
}

const DWORD CTsDescrambler::GetInputNum(void) const
{
	return 1;
}

const DWORD CTsDescrambler::GetOutputNum(void) const
{
	return 1;
}

const bool CTsDescrambler::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;

	if(m_hRecvThread) {
		EnterCriticalSection(&cs);
		if(m_nCount == CACHE_MAX) {
			while(m_nCount > 0) {
				m_PacketCache[m_nRead]->Delete();
				m_nRead++;
				m_nCount--;
				if(m_nRead == CACHE_MAX)
					m_nRead = 0;
			}
			printf("CTsDescrambler LbVI[o[t[\n");
		}
		else {
			m_PacketCache[m_nWrite] = static_cast<CTsPacket *>(pMediaData);
			m_nWrite++;
			m_nCount++;
			if(m_nWrite == CACHE_MAX)
				m_nWrite = 0;
		}
		LeaveCriticalSection(&cs);
	}
	else {
		InputMediaBuffer(static_cast<CTsPacket *>(pMediaData));
	}
	return true;
}

const bool CTsDescrambler::InputMediaBuffer(CTsPacket *pTsPacket)
{
	bool bPlainPacket = true;

	// ̓pPbgJEg
	if(m_dwInputPacketCount < 0xFFFFFFFF)m_dwInputPacketCount++;

	// PID[eBO
	if(!ProcPatPacket(pTsPacket)){
		if(!ProcPmtPacket(pTsPacket)){
			if(!ProcEcmPacket(pTsPacket)){
				// PATAPMTAECMȊÕpPbg
				DescramblePacket(pTsPacket);
			}			
		}
	}

	if(bPlainPacket){
		// o̓pPbgJEg
		if(m_dwOutputPacketCount < 0xFFFFFFFF)m_dwOutputPacketCount++;

		// pPbgfR[_Ƀf[^n
		OutputMedia(static_cast<CMediaData *>(pTsPacket));
		}
	else{
		// s\̏ꍇ̓pPbgj
		static_cast<CMediaData *>(pTsPacket)->Delete();
		//pTsPacket->Delete();
		}

	return true;
}

const bool CTsDescrambler::OpenBcasCard(DWORD *pErrorCode)
{
	// J[h[_B-CASJ[hĊJ
	const bool bReturn = m_BcasCard.OpenCard();
	
	// G[R[hZbg
	if(pErrorCode)*pErrorCode = m_BcasCard.GetLastError();

	return bReturn;
}

void CTsDescrambler::CloseBcasCard(void)
{
	// B-CASJ[h
	m_BcasCard.CloseCard();
}

const bool CTsDescrambler::GetBcasCardID(BYTE *pCardID)
{
	// J[hID擾
	const BYTE *pBuff = m_BcasCard.GetBcasCardID();
	
	// obt@ɃRs[
	if(pCardID && pBuff)::CopyMemory(pCardID, pBuff, 6);
	
	return (pBuff)? true : false;
}

const DWORD CTsDescrambler::GetInputPacketCount(void) const
{
	// ̓pPbgԂ
	return m_dwInputPacketCount;
}

const DWORD CTsDescrambler::GetOutputPacketCount(void) const
{
	// o̓pPbgԂ
	return m_dwOutputPacketCount;
}

const bool CTsDescrambler::ProcPatPacket(const CTsPacket *pTsPacket)
{
	// PAT̃pPbg
	if(pTsPacket->GetPID() != 0x0000)return false;
	
	// PATe[u\z
	if(!m_PatTable.StorePacket(pTsPacket))return true;

	// e[uXVꂽAECM/PMTXgXV({͍݂̂̍XV̕H)
	m_PmtList.clear();
	m_PmtList.resize(m_PatTable.GetPmtNum());

	for(WORD wIndex = 0 ; wIndex < m_PatTable.GetPmtNum() ; wIndex++){
		// PMT PIDZbg
		m_PmtList[wIndex].wPmtPID = m_PatTable.GetPmtPID(wIndex);
		}
		
	return true;
}

const bool CTsDescrambler::ProcPmtPacket(const CTsPacket *pTsPacket)
{
	// PMT̃pPbg
	for(WORD wIndex = 0 ; wIndex < m_PatTable.GetPmtNum() ; wIndex++){
		if(pTsPacket->GetPID() == m_PmtList[wIndex].wPmtPID){
			if(m_PmtList[wIndex].PmtTable.StorePacket(pTsPacket)){
				// e[uXVꂽAECMXgXV
				OnPmtUpdate(m_PmtList[wIndex].PmtTable);
				}
			
			return true;
			}		
		}

	return false;
}

const bool CTsDescrambler::ProcEcmPacket(const CTsPacket *pTsPacket)
{
	// ECM̃pPbg
	for(m_wEcmSetIndex = 0 ; m_wEcmSetIndex < m_EcmList.size() ; m_wEcmSetIndex++){
		if(pTsPacket->GetPID() == m_EcmList[m_wEcmSetIndex].wEcmPID){
			// ECMZNV\z			
			m_EcmList[m_wEcmSetIndex].EcmSectionParser.StorePacket(pTsPacket);
			return true;
			}		
		}

	return false;
}

void CTsDescrambler::OnPmtUpdate(const CPmtTable &PmtTable)
{
	const WORD wEcmPID = PmtTable.GetCaMethodDesc()->GetCaPID();

	if(wEcmPID >= 0x1FFF)return;

	// ECM PID}bvɓo^
	for(WORD wIndex = 0 ; wIndex < PmtTable.GetEsInfoNum() ; wIndex++){
		if(PmtTable.GetEsPID(wIndex) < 0x1FFF){	
			m_awEcmPidMap[PmtTable.GetEsPID(wIndex)] = wEcmPID;
			}
		}

	// ECMXgāAȂΒǉ
	for(WORD wIndex = 0 ; wIndex < m_EcmList.size() ; wIndex++){
		if(wEcmPID == m_EcmList[wIndex].wEcmPID)return;
		}

	// VKECMZbg
	if(m_BcasCard.GetSystemKey()){
		// ECMZbgǉ
		TAG_ECMSET NewEcmSet;
		NewEcmSet.wEcmPID = wEcmPID;
		NewEcmSet.EcmSectionParser.SetRecvCallback(true, CTsDescrambler::OnEcmSection, (PVOID)this);
		NewEcmSet.Decoder.Initialize(m_BcasCard.GetSystemKey(), m_BcasCard.GetInitialCbc());
		m_EcmList.push_back(NewEcmSet);
		}
}

CMulti2Decoder * CTsDescrambler::GetDecoderByPID(const WORD wPID)
{
	if(wPID >= 0x1FFF)return NULL;
	
	// ECMPIDɑΉfR[_
	for(WORD wEcmIndex = 0 ; wEcmIndex < m_EcmList.size() ; wEcmIndex++){
		if(m_EcmList[wEcmIndex].wEcmPID == m_awEcmPidMap[wPID]){
			return &m_EcmList[wEcmIndex].Decoder;
			}
		}

	return NULL;
}

const bool CTsDescrambler::DescramblePacket(CTsPacket *pTsPacket)
{
	if(!pTsPacket->HavePayload() || !pTsPacket->m_Header.byTransportScramblingCtrl)return true;

	// fR[_擾
	CMulti2Decoder * const pDecoder = GetDecoderByPID(pTsPacket->GetPID());
	if(!pDecoder)return false;

	// XNuΏۗ̈
	BYTE *pSrcData = pTsPacket->m_Payload.m_pHexData;
	BYTE bySrcSize = pTsPacket->m_Payload.m_byDataLength;

	// yC[hJnʒu␳
	if(pTsPacket->m_Header.bPayloadUnitStartIndicator){
		pSrcData--;
		bySrcSize++;
		}

	// XNu
	if(!pDecoder->Decode(pSrcData, (DWORD)bySrcSize, pTsPacket->m_Header.byTransportScramblingCtrl))return false;

	// gX|[gXNuĐݒ
	pTsPacket->SetAt(3, pTsPacket->GetAt(3) & 0x3F);
	pTsPacket->m_Header.byTransportScramblingCtrl = 0;

	return true;
}

void CALLBACK CTsDescrambler::OnEcmSection(const CPsiSection *pSection, const PVOID pParam)
{
	CTsDescrambler *pThis = static_cast<CTsDescrambler *>(pParam);
	TAG_ECMSET &EcmSet = pThis->m_EcmList[pThis->m_wEcmSetIndex];

	// ECMȂ΃LbVĂL[gp
	if(EcmSet.LastEcmSection == *pSection)return;

	// ECMB-CASJ[hɓnăL[擾
	const BYTE *KsData = pThis->m_BcasCard.GetKsFromEcm(pSection->GetData(), pSection->GetSize());

	// XNuL[XV
	EcmSet.Decoder.SetScrambleKey(KsData);

	//// L[擾s̏ꍇB-CASJ[hăI[v
	if(!KsData) {
		// J[h[_œǂݍ߂ȂAs1̂ݍăI[vsB
		if(pThis->m_BcasCard.GetLastError() == BCEC_TRANSMITERROR && !pThis->m_bReOpen) {
			TRACE("B-CASJ[h[_ăI[v\n");
			pThis->OpenBcasCard();
			pThis->m_bReOpen = TRUE;
			KsData = pThis->m_BcasCard.GetKsFromEcm(pSection->GetData(), pSection->GetSize());
			EcmSet.Decoder.SetScrambleKey(KsData);
		}
	}
	else {
		pThis->m_bReOpen = FALSE;
	}
		
	// ŏIZNVXV
	EcmSet.LastEcmSection = *pSection;
}
